exec('entrer_valeurs.sce',-1)
exec('voir_possibilite.sce',-1)
function jouer_sudoku(S,varargin)
    // créer ou récupérer la liste des coups précédents 
    if length(varargin)>0 then L=varargin(1) 
    // au départ on stocke S dans la liste des coups précédents
    else L=list(S)  
    end
    // choix du coup suivant
    item=['choisir une valeur ';                   //  num=1
    'annuler dernier choix';                       //  num=2
    'afficher les possibilités pour chaque case';  //  num=3
    'afficher le sudoku';                          //  num=4
    'enregistrer la partie';]                      //  num=5
    texte=['double cliquer sur votre choix']
    num=x_choose(item,texte,'abandonner')
    // traitement du choix
    select num
    case 1 then 
        S1=entrer_valeurs(S,L($))
        if and(S1==S)  then   // aucune modification!
        // on rejoue sans modifier la liste des coups
            jouer_sudoku(S,L) 
        //toutes les cases sont bien remplies   
        elseif and(S1<>0) then 
            disp('gagné!')     // c'est gagné
        else                   // continuer à jouer
            L($+1)=S    // on ajoute le coup précédent à la liste
            jouer_sudoku(S1,L) // on rejoue
        end
    case 2 then               // annuler le coup précédent
        if size(L)>1 then     // on peut annuler le coup précédent
            S0=L($)      // on récupère l'état précédent du sudoku
            L($)=null()       // puis on le supprime de la liste
            disp('dernier choix annulé')
        else S0=S              // S  est le sudoku de départ  
            L=list()           // liste des coups précédents vides
            disp('vous êtes revenu au sudoku de départ!')
        end
        jouer_sudoku(S0,L)     // on rejoue 
    case 3 then voir_possibilite(S)   // affiche possibilités 
        jouer_sudoku(S,L)             // puis on rejoue
    case 4 then            // afficher le sudoku dans la console
        K=string(S)        // convertir S en chaînes de caractères
        K(find(S==0))='_'  // signale  les cases libres
        disp(K,'état actuel du sudoku :')
        jouer_sudoku(S,L)  // puis on rejoue
    case 5 then // enregistrer la partie
        path=uiputfile('*.sod',pwd(),'choisir fichier pour sauvegarder la partie:')
        if path<>'' then    //  on a bien saisi un chemin 
            save('''+path+''','S','L') // on sauve S et L
            disp('partie sauvegardée')
            else disp('partie non sauvegardée')
        end
    else // arrêt prématuré du jeu  sans sauvegarde
        disp('au revoir!')
    end
endfunction
